from abc import ABC

class OffsetSpec(ABC):
    @classmethod
    def earliest(cls) -> EarliestSpec: ...
    @classmethod
    def latest(cls) -> LatestSpec: ...
    @classmethod
    def max_timestamp(cls) -> MaxTimestampSpec: ...
    @classmethod
    def for_timestamp(cls, timestamp: int) -> TimestampSpec: ...
    def __init__(self, index: int) -> None: ...

class TimestampSpec(OffsetSpec):
    def __init__(self, timestamp: int) -> None: ...

class MaxTimestampSpec(OffsetSpec): ...
class LatestSpec(OffsetSpec): ...
class EarliestSpec(OffsetSpec): ...

class ListOffsetsResultInfo:
    offset: int
    timestamp: int
    leader_epoch: int
    def __init__(self, offset: int, timestamp: int, leader_epoch: int) -> None: ...
